version: 4

annotations:
  screwdriver.cd/chainPR: true

shared:
  annotations:
    target-npm: &npm
      template: ryot/npm-publish@latest
      image: docker.ouroath.com:4443/paas.ynodejs.images/node14-ylinux7-slim-sd:1-CURRENT
      annotations:
        screwdriver.cd/mergeSharedSteps: true
      steps:
        - install: |
            npm install
        - build: |
            echo "Nothing to build..."
        - publish_npm: |
            meta_set npm.package.version $(node -pe "require('./package.json').version")
            if [[ -z "${SD_PULL_REQUEST}" ]]; then
              meta_set sd.branch.name "${GIT_BRANCH/origin\//}"
            else
              meta_set sd.branch.name "${PR_BRANCH_NAME/origin\//}"
              meta_set sd.pr.base "${PR_BASE_BRANCH_NAME}"
            fi

            export PACKAGE_VERSION=$(eval echo $PACKAGE_VERSION)
            export PACKAGE_TAG=$(eval echo $PACKAGE_TAG)
            echo "Publishing ${PACKAGE_VERSION} (as tag ${PACKAGE_TAG})..."

            npm version "${PACKAGE_VERSION}"
            npm publish --registry "${NPM_REGISTRY}" --tag "${PACKAGE_TAG}"

jobs:
  release-npm:
    <<: *npm
    requires: [~tag]
    environment:
      PACKAGE_TAG: "latest"
      PACKAGE_VERSION: "$(meta_get sd.tag.name)"

  feature-npm:
    <<: *npm
    requires: [~pr:master]
    environment:
      PACKAGE_TAG: "feature${SD_PULL_REQUEST}"
      PACKAGE_VERSION: "$(meta_get npm.package.version)-$(meta_get sd.pr.base)-feature${SD_PULL_REQUEST}-${SD_BUILD_ID}"

  snapshot-npm:
    <<: *npm
    requires: [~commit:master]
    environment:
      PACKAGE_TAG: "snapshot"
      PACKAGE_VERSION: "$(meta_get npm.package.version)-$(meta_get sd.branch.name)-snapshot-${SD_BUILD_ID}"
